deferred class
	AST_DECLARATION

inherit
	AST_NODE

feature {ANY}

	identifier: STRING

	source_info: SOURCE_INFO assign set_source_info

	set_source_info (a_source_info: SOURCE_INFO)
		do
			source_info := a_source_info
		ensure
			source_info = a_source_info
		end

feature {ANY} -- AST_NODE

	make_copy (a_other: like Current)
		do
			identifier := a_other.identifier.twin
			source_info := a_other.source_info
		end

invariant
	identifier /= Void and then not identifier.is_empty
	attached {AST_TRANSLATION_UNIT} parent implies source_info /= Void

end
