deferred class
	AST_VISITOR

feature {ANY}

	pre_visit (node: AST_NODE) deferred end
	post_visit (node: AST_NODE) deferred end

feature {ANY}

	visit_array_type (node: AST_ARRAY_TYPE): BOOLEAN deferred end
	visit_assembler_statement (node: AST_ASSEMBLER_STATEMENT): BOOLEAN deferred end
	visit_asm_operand (node: AST_ASM_OPERAND): BOOLEAN deferred end
	visit_attribute (node: AST_GCC_ATTRIBUTE): BOOLEAN deferred end
	visit_attribute_specifier (node: AST_GCC_ATTRIBUTE_SPECIFIER): BOOLEAN deferred end
	visit_basic_type (node: AST_BASIC_TYPE): BOOLEAN deferred end
	visit_bit_field (node: AST_BITFIELD): BOOLEAN deferred end
	visit_builtin_va_arg_call (node: AST_BUILTIN_VA_ARG_CALL): BOOLEAN deferred end
	visit_alignof_call (node: AST_ALIGNOF_CALL): BOOLEAN deferred end
	visit_initializer (node: AST_INITIALIZER): BOOLEAN deferred end
	visit_assignment_expression (node: AST_ASSIGNMENT_EXPRESSION): BOOLEAN deferred end
	visit_boolean_constant (node: AST_BOOLEAN_CONSTANT): BOOLEAN deferred end
	visit_cast_expression (node: AST_CAST_EXPRESSION): BOOLEAN deferred end
	visit_character_constant (node: AST_CHARACTER_CONSTANT): BOOLEAN deferred end
	visit_compound_statement (node: AST_COMPOUND_STATEMENT): BOOLEAN deferred end
	visit_decimal_constant (node: AST_DECIMAL_CONSTANT): BOOLEAN deferred end
	visit_eiffel_expression (node: AST_EIFFEL_EXPRESSION): BOOLEAN deferred end
	visit_eiffel_jump (node: AST_EIFFEL_JUMP): BOOLEAN deferred end
	visit_eiffel_jump_target (node: AST_EIFFEL_JUMP_TARGET): BOOLEAN deferred end
	visit_eiffel_string_type (node: AST_EIFFEL_STRING_TYPE): BOOLEAN deferred end
	visit_eiffel_type (node: AST_EIFFEL_TYPE): BOOLEAN deferred end
	visit_enum_declaration (node: AST_ENUM_DECLARATION): BOOLEAN deferred end
	visit_enum_type (node: AST_ENUM_TYPE): BOOLEAN deferred end
	visit_expression_statement (node: AST_EXPRESSION_STATEMENT): BOOLEAN deferred end
	visit_floating_point_constant (node: AST_FLOATING_POINT_CONSTANT): BOOLEAN deferred end
	visit_function_call (node: AST_FUNCTION_CALL): BOOLEAN deferred end
	visit_function_declaration (node: AST_FUNCTION_DECLARATION): BOOLEAN deferred end
	visit_function_type (node: AST_FUNCTION_TYPE): BOOLEAN deferred end
	visit_generic_expression (node: AST_GENERIC_EXPRESSION): BOOLEAN deferred end
	visit_hex_constant (node: AST_HEX_CONSTANT): BOOLEAN deferred end
	visit_if_statement (node: AST_IF_STATEMENT): BOOLEAN deferred end
	visit_jump_statement (node: AST_JUMP_STATEMENT): BOOLEAN deferred end
	visit_labeled_statement (node: AST_LABELED_STATEMENT): BOOLEAN deferred end
	visit_octal_constant (node: AST_OCTAL_CONSTANT): BOOLEAN deferred end
	visit_parameter_list (node: AST_PARAMETER_LIST): BOOLEAN deferred end
	visit_parenthesized_expression (node: AST_PARENTHESIZED_EXPRESSION): BOOLEAN deferred end
	visit_pointer_type (node: AST_POINTER_TYPE): BOOLEAN deferred end
	visit_postfix_expression (node: AST_POSTFIX_EXPRESSION): BOOLEAN deferred end
	visit_sizeof_expression (node: AST_SIZEOF_EXPRESSION): BOOLEAN deferred end
	visit_string_constant (node: AST_STRING_CONSTANT): BOOLEAN deferred end
	visit_struct_declaration (node: AST_STRUCT_DECLARATION): BOOLEAN deferred end
	visit_struct_type (node: AST_STRUCT_TYPE): BOOLEAN deferred end
	visit_switch_case (node: AST_SWITCH_CASE): BOOLEAN deferred end
	visit_switch_default (node: AST_SWITCH_DEFAULT): BOOLEAN deferred end
	visit_switch_statement (node: AST_SWITCH_STATEMENT): BOOLEAN deferred end
	visit_translation_unit (node: AST_TRANSLATION_UNIT): BOOLEAN deferred end
	visit_typedef_declaration (node: AST_TYPEDEF_DECLARATION): BOOLEAN deferred end
	visit_typedef_type (node: AST_TYPEDEF_TYPE): BOOLEAN deferred end
	visit_unary_expression (node: AST_UNARY_EXPRESSION): BOOLEAN deferred end
	visit_variable_declaration (node: AST_VARIABLE_DECLARATION): BOOLEAN deferred end
	visit_variable_expression (node: AST_VARIABLE_EXPRESSION): BOOLEAN deferred end
	visit_while_statement (node: AST_WHILE_STATEMENT): BOOLEAN deferred end

feature {ANY}

	end_visit_array_type (node: AST_ARRAY_TYPE) deferred end
	end_visit_assembler_statement (node: AST_ASSEMBLER_STATEMENT) deferred end
	end_visit_asm_operand (node: AST_ASM_OPERAND) deferred end
	end_visit_attribute (node: AST_GCC_ATTRIBUTE) deferred end
	end_visit_attribute_specifier (node: AST_GCC_ATTRIBUTE_SPECIFIER) deferred end
	end_visit_basic_type (node: AST_BASIC_TYPE) deferred end
	end_visit_bit_field (node: AST_BITFIELD) deferred end
	end_visit_builtin_va_arg_call (node: AST_BUILTIN_VA_ARG_CALL) deferred end
	end_visit_alignof_call (node: AST_ALIGNOF_CALL) deferred end
	end_visit_initializer (node: AST_INITIALIZER) deferred end
	end_visit_assignment_expression (node: AST_ASSIGNMENT_EXPRESSION) deferred end
	end_visit_cast_expression (node: AST_CAST_EXPRESSION) deferred end
	end_visit_boolean_constant (node: AST_BOOLEAN_CONSTANT) deferred end
	end_visit_character_constant (node: AST_CHARACTER_CONSTANT) deferred end
	end_visit_compound_statement (node: AST_COMPOUND_STATEMENT) deferred end
	end_visit_decimal_constant (node: AST_DECIMAL_CONSTANT) deferred end
	end_visit_eiffel_expression (node: AST_EIFFEL_EXPRESSION) deferred end
	end_visit_eiffel_jump (node: AST_EIFFEL_JUMP) deferred end
	end_visit_eiffel_jump_target (node: AST_EIFFEL_JUMP_TARGET) deferred end
	end_visit_eiffel_string_type (node: AST_EIFFEL_STRING_TYPE) deferred end
	end_visit_eiffel_type (node: AST_EIFFEL_TYPE) deferred end
	end_visit_enum_declaration (node: AST_ENUM_DECLARATION) deferred end
	end_visit_enum_type (node: AST_ENUM_TYPE) deferred end
	end_visit_expression_statement (node: AST_EXPRESSION_STATEMENT) deferred end
	end_visit_floating_point_constant (node: AST_FLOATING_POINT_CONSTANT) deferred end
	end_visit_function_call (node: AST_FUNCTION_CALL) deferred end
	end_visit_function_declaration (node: AST_FUNCTION_DECLARATION) deferred end
	end_visit_function_type (node: AST_FUNCTION_TYPE) deferred end
	end_visit_generic_expression (node: AST_GENERIC_EXPRESSION) deferred end
	end_visit_hex_constant (node: AST_HEX_CONSTANT) deferred end
	end_visit_if_statement (node: AST_IF_STATEMENT) deferred end
	end_visit_jump_statement (node: AST_JUMP_STATEMENT) deferred end
	end_visit_labeled_statement (node: AST_LABELED_STATEMENT) deferred end
	end_visit_octal_constant (node: AST_OCTAL_CONSTANT) deferred end
	end_visit_parameter_list (node: AST_PARAMETER_LIST) deferred end
	end_visit_parenthesized_expression (node: AST_PARENTHESIZED_EXPRESSION) deferred end
	end_visit_pointer_type (node: AST_POINTER_TYPE) deferred end
	end_visit_postfix_expression (node: AST_POSTFIX_EXPRESSION) deferred end
	end_visit_sizeof_expression (node: AST_SIZEOF_EXPRESSION) deferred end
	end_visit_string_constant (node: AST_STRING_CONSTANT) deferred end
	end_visit_struct_declaration (node: AST_STRUCT_DECLARATION) deferred end
	end_visit_struct_type (node: AST_STRUCT_TYPE) deferred end
	end_visit_switch_case (node: AST_SWITCH_CASE) deferred end
	end_visit_switch_default (node: AST_SWITCH_DEFAULT) deferred end
	end_visit_switch_statement (node: AST_SWITCH_STATEMENT) deferred end
	end_visit_translation_unit (node: AST_TRANSLATION_UNIT) deferred end
	end_visit_typedef_declaration (node: AST_TYPEDEF_DECLARATION) deferred end
	end_visit_typedef_type (node: AST_TYPEDEF_TYPE) deferred end
	end_visit_unary_expression (node: AST_UNARY_EXPRESSION) deferred end
	end_visit_variable_declaration (node: AST_VARIABLE_DECLARATION) deferred end
	end_visit_variable_expression (node: AST_VARIABLE_EXPRESSION) deferred end
	end_visit_while_statement (node: AST_WHILE_STATEMENT) deferred end

end
